"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Expander = void 0;
const web_1 = require("@react-spring/web");
const react_1 = __importDefault(require("react"));
const react_use_measure_1 = __importDefault(require("react-use-measure"));
const utilities_1 = require("../utilities");
const Expander = ({ children, isExpanded = false, style }) => {
    const previous = (0, utilities_1.usePrevious)(isExpanded);
    const [ref, { height: viewHeight }] = (0, react_use_measure_1.default)();
    const { height, opacity, zIndex } = (0, web_1.useSpring)({
        from: {
            height: 0,
            opacity: 0,
            zIndex: -1000,
        },
        to: {
            height: isExpanded ? viewHeight : 0,
            opacity: isExpanded ? 1 : 0,
            zIndex: isExpanded ? 1 : -1000,
        },
    });
    const finalStyle = {
        height: isExpanded && previous === isExpanded ? 'auto' : height,
        opacity,
        zIndex,
        position: 'relative',
        ...style,
    };
    return (react_1.default.createElement(web_1.animated.div, { style: finalStyle },
        react_1.default.createElement(web_1.animated.div, { ref: ref, children: children })));
};
exports.Expander = Expander;
//# sourceMappingURL=expander.js.map