"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const utilities_1 = require("../utilities");
const useGoogleCharts_1 = __importDefault(require("../hooks/useGoogleCharts"));
const GaugeChart = ({ caption, id, options = null, value = 0 }) => {
    const gc = (0, useGoogleCharts_1.default)();
    const [chartData, setChartData] = (0, react_1.useState)();
    const [chart, setChart] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        if (!utilities_1.isBrowser || !gc)
            return;
        const cd = new gc.visualization.DataTable();
        cd.addColumn('number', caption);
        cd.addRows(1);
        cd.setCell(0, 0, value);
        setChartData(cd);
        const newChart = new gc.visualization.Gauge(document.getElementById(id));
        newChart.draw(cd, options);
        setChart(newChart);
    }, [gc]);
    (0, react_1.useEffect)(() => {
        if (!chartData || !chart)
            return;
        chartData.setCell(0, 0, value);
        chart.draw(chartData, options);
    }, [value]);
    return (react_1.default.createElement("div", { id: id }, caption));
};
exports.default = GaugeChart;
//# sourceMappingURL=gaugeChart.js.map