"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Masonry = void 0;
const react_1 = __importStar(require("react"));
const utilities_1 = require("../utilities");
const Masonry = ({ children, gap = '10px' }) => {
    const columnCount = (0, utilities_1.useMasonryColumns)();
    const [columns, setColumns] = (0, react_1.useState)([]);
    (0, react_1.useEffect)(() => {
        const newCols = [];
        const colWidth = (100 / columnCount) + '%';
        const colStyle = {
            width: colWidth,
        };
        if (children) {
            const childArray = children;
            for (let i = 0; i < columnCount; i++) {
                const rows = [];
                for (let j = i; j < childArray.length; j += columnCount) {
                    rows.push(react_1.default.createElement("div", { key: j, style: { margin: gap + ' 0px' } }, childArray[j]));
                }
                newCols.push(react_1.default.createElement("div", { key: i, style: colStyle }, rows));
            }
            setColumns(newCols);
        }
        else {
            setColumns([]);
        }
    }, [children, columnCount]);
    return (react_1.default.createElement("div", { style: { display: 'flex', justifyContent: 'space-between', gap } }, columns));
};
exports.Masonry = Masonry;
//# sourceMappingURL=masonry.js.map