"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tree = void 0;
const web_1 = require("@react-spring/web");
const react_1 = __importStar(require("react"));
const react_use_measure_1 = __importDefault(require("react-use-measure"));
const utilities_1 = require("../utilities");
const Content = {
    willChange: 'transform, opacity, height',
    marginLeft: '6px',
    padding: '0px 0px 0px 14px',
    borderLeft: '1px dashed rgba(255, 255, 255, 0.4)',
    overflow: 'hidden',
};
const Frame = {
    position: 'relative',
    padding: '4px 0px 0px 0px',
    textOverflow: 'ellipsis',
    whiteSpace: 'nowrap',
    overflowX: 'hidden',
    verticalAlign: 'middle',
    color: '#24292e',
    fill: '#24292e',
};
const Title = {
    verticalAlign: 'middle',
};
exports.Tree = react_1.default.memo(({ children, name, style, defaultOpen = false }) => {
    const [isOpen, setOpen] = (0, react_1.useState)(defaultOpen);
    const previous = (0, utilities_1.usePrevious)(isOpen);
    const [ref, { height: viewHeight }] = (0, react_use_measure_1.default)();
    const { height, opacity, y } = (0, web_1.useSpring)({
        from: { height: 0, opacity: 0, y: 0 },
        to: {
            height: isOpen ? viewHeight : 0,
            opacity: isOpen ? 1 : 0,
            y: isOpen ? 0 : 20,
        },
    });
    return (react_1.default.createElement("div", { style: Frame },
        react_1.default.createElement("div", { style: { ...Title, ...style }, onClick: () => setOpen(!isOpen) }, name),
        react_1.default.createElement(web_1.animated.div, { style: {
                ...Content,
                opacity,
                height: isOpen && previous === isOpen ? 'auto' : height,
            } },
            react_1.default.createElement(web_1.a.div, { ref: ref, style: { y }, children: children }))));
});
//# sourceMappingURL=tree.js.map