"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const useGoogle_1 = __importDefault(require("./useGoogle"));
function useGoogleCharts() {
    const [isChartsReady, setIsChartsReady] = (0, react_1.useState)(false);
    const g = (0, useGoogle_1.default)();
    (0, react_1.useEffect)(() => {
        if (isChartsReady || !g)
            return;
        g.charts.load('current', { 'packages': ['corechart'] });
        g.charts.load('current', { 'packages': ['gauge'] });
        g.charts.setOnLoadCallback(() => {
            console.log('Charts ready');
            setIsChartsReady(true);
        });
    }, [g]);
    return isChartsReady && g;
}
exports.default = useGoogleCharts;
//# sourceMappingURL=useGoogleCharts.js.map