"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
function useScriptLoader(scriptUrl) {
    const [isScriptLoaded, setIsScriptLoaded] = (0, react_1.useState)(false);
    (0, react_1.useEffect)(() => {
        if (isScriptLoaded)
            return;
        const script = document.createElement('script');
        script.src = scriptUrl;
        script.async = true;
        const handleScriptLoad = () => {
            setIsScriptLoaded(true);
        };
        const handleScriptError = (error) => {
            console.error(`Failed to load script: ${scriptUrl}`, error);
        };
        script.addEventListener('load', handleScriptLoad);
        script.addEventListener('error', handleScriptError);
        document.body.appendChild(script);
        return () => {
            script.removeEventListener('load', handleScriptLoad);
            script.removeEventListener('error', handleScriptError);
        };
    }, [scriptUrl]);
    return isScriptLoaded;
}
exports.default = useScriptLoader;
//# sourceMappingURL=useScriptLoader.js.map